<h1 align="center">
  🚀 FastAPI Cookiecutter
  <br>
  <sub>⚡ Your Ultimate FastAPI Project Starter ⚡</sub>
</h1>

<div align="center">

[![Stars](https://img.shields.io/github/stars/Mohammad222PR/fastapi-cookiecutter?logo=starship&color=gold)](https://github.com/Mohammad222PR/fastapi-cookiecutter/stargazers)
[![Forks](https://img.shields.io/github/forks/Mohammad222PR/fastapi-cookiecutter?logo=git&color=9cf)](https://github.com/Mohammad222PR/fastapi-cookiecutter/forks)
[![Issues](https://img.shields.io/github/issues/Mohammad222PR/fastapi-cookiecutter?logo=github&color=red)](https://github.com/Mohammad222PR/fastapi-cookiecutter/issues)
[![License](https://img.shields.io/github/license/Mohammad222PR/fastapi-cookiecutter?logo=open-source-initiative&color=green)](https://github.com/Mohammad222PR/fastapi-cookiecutter/blob/main/LICENSE)

</div>

---

## 📖 What is FastAPI Cookiecutter?
**FastAPI Cookiecutter** is a badass template for generating production-ready FastAPI projects in minutes. Built for developers who hate boilerplate and love flexibility, it’s packed with:

- 🛠️ **Modular Blueprint**: Pre-structured for APIs, models, and services.
- 🌍 **Database Choices**: PostgreSQL or SQLite, you decide.
- ⚡ **Optional Boosts**: Docker, Redis, CI/CD—pick what you need.
- 🔍 **Pro Tools**: Health checks, migrations, and tests out of the box.

### Why This Template?
- ⚡ **Instant Start**: Zero-to-API faster than you can say "REST".
- 🔧 **Total Control**: Customize with a few quick prompts.
- 🌐 **Scales Hard**: From side projects to enterprise beasts.
- 📊 **Clean Code**: Structure that actually makes sense.

---

## ✨ Features
| Feature             | Description                              |
|---------------------|------------------------------------------|
| 🚀 **FastAPI Base** | Async-powered API goodness.             |
| 🌍 **DB Options**   | SQLite or PostgreSQL on tap.            |
| ⚡ **Redis Power**  | Add caching with a single "yes".        |
| 🐳 **Docker Vibes** | Containerize it—or don’t. Your call.    |
| 🤖 **CI/CD Flow**   | GitHub Actions, optional and awesome.   |

---

## 🚀 Get Started
1. **Install Cookiecutter**:
   ```bash
   pip install cookiecutter
   ```
2. **Generate a Project**:
   ```bash
   cookiecutter gh:<your-username>/fastapi-cookiecutters
   ```
   Replace `<your-username>` with your GitHub username.
3. **Customize It**:
   Answer the prompts—name your project, pick a DB, add Docker, whatever you’re feeling.

Boom! Your FastAPI app is ready to roll.

---

## 🔧 Usage Examples
```bash
# Basic setup (SQLite, no extras)
cookiecutter gh:<your-username>/fastapi-cookiecutters

# Full power (Postgres, Docker, Redis, CI/CD)
cookiecutter gh:<your-username>/fastapi-cookiecutters --no-input \
  project_name="MyAPI" database="postgres" use_redis="yes" use_docker="yes" use_ci_cd="yes"
```

Check the generated `README.md` for what’s next!

---

## 🤝 Contributing
Dig this template? Let’s make it epic!
1. Fork it 🍴
2. Clone it:
   ```bash
   git clone https://github.com/Mohammad222PR/fastapi-cookiecutter.git
   cd fastapi-cookiecutter
   pip install -r requirements.txt
   ```
3. Test your changes:
   ```bash
   cookiecutter . --no-input
   ```
4. Push & PR:
   ```bash
   git checkout -b feature/sick-idea
   git commit -m "Add sick idea"
   git push origin feature/sick-idea
   ```
5. Open a Pull Request on [GitHub](https://github.com/<your-username>/fastapi-cookiecutter/pulls)

More details in our [Contributing Guide](CONTRIBUTING.md)!

---

## ⚖️ License
FastAPI Cookiecutter rocks the [MIT License](LICENSE). Use it, tweak it, share it—just keep it chill and legal.

---

## 🌟 Show Your Support
- ⭐ Star us on [GitHub](https://github.com/<your-username>/fastapi-cookiecutter)!
- 🐛 Drop bugs or ideas in [Issues](https://github.com/<your-username>/fastapi-cookiecutter/issues).
- 💬 Tell us how you’re using it—hit us up!

---

> **Pro Tip!** 📢  
> Customize it your way. This is your FastAPI launchpad—make it fly!

Crafted with 🔥 by @Mohammad222PR.
